-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-05 22:33:16"
-- Version := "0.1.4b"
package body Lib.Elhoim is
   
   task body Elhoim_Process is
   begin
      loop
	 select
	    accept Send (Object : out Abstracted_Access) do
	       if World.T.Obj_Cur /= null then
		  Object := World.T.Obj_Cur;
	       end if;
	    end Send;
	 or
	    accept Think (Object : in out Abstracted_Access) do
	       if World.T.Obj_Cur /= null then
		  Object := World.T.Obj_Cur;
	       end if;
	    end Think;
	 or
	    accept Send (Wline : out Wide_String_Access) do
	       null;
	    end Send;
	 or
	    accept Receive (Wline : in Wide_String) do
	       null;
	    end Receive;
	 end select;
      end loop;
   end Elhoim_Process;
end Lib.Elhoim ; 
