-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-03 11:57:08"
-- Version := "1.0.0b"
package Lib.Enumes is
   
   type Mode_Enum is (Null_Mode, Quit_Mode, Auth_Mode, Dialog_Mode, 
		      Devel_Mode, Organizer_Mode, Multi_Mode, Shell_Mode, 
		      Execut_mode, Help_Mode, Edit_Mode, Command_Mode, 
		       Account_Mode, Tasking, Hander_Mode);
   
   type Multi_Enum is (Edit_Mode, Command_Mode, 
		       Account_Mode, Tasking, Hander_Mode);
   
   type Term_Enum is (Linux, Xterm, Uncknow, MS_Windows);
   
   
   type Dialup_Enum is (Sys, Intern, Neura, Eng, web);
end Lib.Enumes ; 
