-- This program is the last attempt of artificial intelligency with Ada.
-- Elhoim is Copyright (C) 2023 Manuel ; 
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
-- Date := "2023-05-19 23:32:47"
-- Version := "0.3.5b"
package Lib.Naming is
   
   Chars_Max : constant Positive := 34;
   
   subtype Word_Range is Positive range 1..Chars_Max;
   
   
   function Name (Num_Char : in Word_Range) return String;
   
   procedure Name (Num_Char : in Word_Range; Word : out String);
   
end Lib.Naming ; 
